<template>
  <!-- 列表 -->
  <ContentWrap>
    <el-button
      type="primary"
      plain
      @click="openForm('create')"
      v-hasPermi="['mes:work-team:create']"
    >
      <Icon icon="ep:plus" class="mr-5px" /> {{ t('FactoryModeling.WorkTeam.detailAddButtonText') }}
    </el-button>
    <el-table v-loading="loading" :data="list" :stripe="true" :show-overflow-tooltip="true">
      <!-- <el-table-column label="ID" align="center" prop="id" /> -->
      <el-table-column :label="t('FactoryModeling.WorkTeam.detailTableJobNoColumn')" align="center" prop="nickName" />
      <!-- <el-table-column label="成员名称" align="center" prop="userName" /> -->
      <el-table-column :label="t('FactoryModeling.WorkTeam.detailTableRoleColumn')" align="center" prop="userRole">
        <template #default="scope">
          <dict-tag :type="DICT_TYPE.MES_WORK_TEAM_USER_ROLE" :value="scope.row.userRole" />
        </template>
      </el-table-column>
      <el-table-column :label="t('FactoryModeling.WorkTeam.detailTableRemarkColumn')" align="center" prop="remark" />
      <el-table-column
        :label="t('FactoryModeling.WorkTeam.detailTableCreateTimeColumn')"
        align="center"
        prop="createTime"
        :formatter="dateFormatter"
        width="180px"
      />
      <el-table-column :label="t('FactoryModeling.WorkTeam.detailTableOperateColumn')" align="center">
        <template #default="scope">
          <el-button
            link
            type="primary"
            @click="openForm('update', scope.row.id)"
            v-hasPermi="['mes:work-team:update']"
          >
            {{ t('FactoryModeling.WorkTeam.tableEditAction') }}
          </el-button>
          <el-button
            link
            type="danger"
            @click="handleDelete(scope.row.id)"
            v-hasPermi="['mes:work-team:delete']"
          >
            {{ t('FactoryModeling.WorkTeam.tableDeleteAction') }}
          </el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页 -->
    <Pagination
      :total="total"
      v-model:page="queryParams.pageNo"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />
  </ContentWrap>
    <!-- 表单弹窗：添加/修改 -->
    <WorkTeamDetailForm ref="formRef" @success="getList" />
</template>
<script setup lang="ts">
import { DICT_TYPE } from '@/utils/dict'
import { dateFormatter } from '@/utils/formatTime'
import { WorkTeamApi } from '@/api/mes/workteam'
import WorkTeamDetailForm from './WorkTeamDetailForm.vue'

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const props = defineProps<{
  workTeamId?: number // 班组id（主表的关联字段）
  teamName?: string
}>()
const loading = ref(false) // 列表的加载中
const list = ref([]) // 列表的数据
const total = ref(0) // 列表的总页数
const queryParams = reactive({
  pageNo: 1,
  pageSize: 10,
  workTeamId: undefined as unknown
})

/** 监听主表的关联字段的变化，加载对应的子表数据 */
watch(
  () => props.workTeamId,
  (val: number) => {
    if (!val) {
      return
    }
    queryParams.workTeamId = val
    handleQuery()
  },
    { immediate: true, deep: true }
)

/** 查询列表 */
const getList = async () => {
  loading.value = true
  try {
    const data = await WorkTeamApi.getWorkTeamDetailPage(queryParams)
    list.value = data.list
    total.value = data.total
  } finally {
    loading.value = false
  }
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.pageNo = 1
  getList()
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type: string, id?: number) => {
  if (!props.workTeamId) {
    message.error(t('FactoryModeling.WorkTeam.validatorSelectWorkTeamFirst'))
    return
  }
  formRef.value.open(type, id, props.workTeamId, props.teamName)
}

/** 删除按钮操作 */
const handleDelete = async (id: number) => {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await WorkTeamApi.deleteWorkTeamDetail(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}
</script>
